/*
 * Copyright (c) 2006, Matt Whitlock and WhitSoft Development
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the names of Matt Whitlock and WhitSoft Development nor the
 *     names of their contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _INCL_PERMDB_H
#define _INCL_PERMDB_H

#include <windows.h>
#include <string>
#include "tree.h"
#include "slimftpd.h"

using namespace std;

#define PERM_READ 0
#define PERM_WRITE 1
#define PERM_LIST 2
#define PERM_ADMIN 3

class PermDB
{
private:
	struct FTPPERM {
		string strVirtual;
		DWORD dwPerms[4];
	};

	tree<FTPPERM> _root;

	static DWORD GetPermFunc(const char *pszVirtual, DWORD dwPermId, tree<FTPPERM> *ptree);
#ifdef SLIMFTPD_VARIABLES
	string ReplaceVariables (string &path);
#endif

public:
	PermDB();
	void SetPerm(const char *pszVirtual, DWORD dwPermId, DWORD dwStatus);
	DWORD GetPerm(const char *pszVirtual, DWORD dwPermId);
	void CopyPermsToRecursive(PermDB *ppdbDestination, const char * pszPath, tree<FTPPERM> *ptree);
	void CopyPermsTo(PermDB *ppdbDestination);

#if (defined SLIMFTPD_VARIABLES) && (defined SLIMFTPD_VARIABLES_USERNAME)
	string strUsername;
#endif
};

#endif
